<template>
  <nav :aria-labelledby="titleId" class="ui-sidebar-nav">
    <slot :title="title" :title-id="titleId" name="title">
      <span
        :id="titleId"
        class="block font-extrabold uppercase leading-tight tracking-wide"
        >{{ title }}</span
      >
    </slot>
    <component
      :is="hasOrderedItems ? 'ol' : 'ul'"
      v-if="preDividerItems.length"
      class="list-none border-b-4 border-dashed pb-2 md:text-base md:leading-normal lg:text-lg [&_li>:is(ol,ul)]:ml-4"
      :class="{
        '!pl-0': !hasOrderedItems,
      }"
    >
      <ui-sidebar-nav-item
        v-for="item of preDividerItems"
        :key="item.label"
        :item="item"
        :parent-is-ordered-list="hasOrderedItems"
      />
    </component>
    <component
      :is="hasOrderedItems ? 'ol' : 'ul'"
      class="md:text-base md:leading-normal lg:text-lg"
      :class="{
        'list-none !pl-0 [&_li>:is(ol,ul)]:ml-4': !hasOrderedItems,
      }"
    >
      <ui-sidebar-nav-item
        v-for="item of items"
        :key="item.label"
        :item="item"
        :parent-is-ordered-list="hasOrderedItems"
      />
    </component>
  </nav>
</template>

<script lang="ts" setup>
import { PropType } from 'vue'
import { SidebarNavItemData } from '../../propInterfaces'
import UiSidebarNavItem from './SidebarNavItem.vue'

defineOptions({
  name: 'UiSidebarNav',
})

defineProps({
  title: {
    type: String,
    default: 'Navigation',
  },
  titleId: {
    type: String,
    default: 'sidebar-nav-title',
  },
  hasOrderedItems: {
    type: Boolean,
    default: false,
  },
  items: {
    type: Array as PropType<SidebarNavItemData[]>,
    default: () => [],
    validator: (arr: SidebarNavItemData[]) => arr.every((item) => item.label),
  },
  preDividerItems: {
    type: Array as PropType<SidebarNavItemData[]>,
    default: () => [],
    validator: (arr: SidebarNavItemData[]) => arr.every((item) => item.label),
  },
})
</script>
